 IncludeFile "PDH_CPU_Usage.pb"
 IncludeFile "graph_meter.pb"
 
Structure gauge  
  imagegad.l  
  imageid.l  
  width.l  
  height.l  
  imagehwnd.l  
  precision.l  
  ticks.l  
EndStructure  
 
Global NewList led.gauge()  
Global NumCores.w
 
ProcedureDLL LEDgadget(number,x,y,width,height,display)  
  AddElement(led())  
  SelectElement(led(),number)  
  led()\width=width  
  led()\height=height  
  led()\imageid=CreateImage(#PB_Any,led()\width,led()\height)  
  StartDrawing(ImageOutput(led()\imageid))  
  Box(0,0,led()\width,led()\height,#Black)  
  ledheight=led()\height-20  
  boxwidth=(led()\width-10-1)/2  
  secondx= 6+boxwidth  
  tickcount=0  
  For a=0 To led()\height-20 Step 4  
    tickcount=tickcount+1  
    Box(5,a,boxwidth,3,$7F00)  
    Box(secondx,a,boxwidth,3,$7F00)  
  Next   
  led()\ticks=tickcount  
  BackColor(RGB(0,0,0)) 
  FrontColor(RGB(0, $FF, 0)) 
  DrawText((led()\width/2)-10, led()\height-15, "0%")  
  StopDrawing()  
  led()\imagegad=ImageGadget(#PB_Any,x,y,width,height,ImageID(led()\imageid),#PB_Image_Border)  
  ProcedureReturn led()\imagegad  
EndProcedure  
 
ProcedureDLL setLEDstate(led,percent)  
  SelectElement(led(),led)  
  tickcount=led()\ticks  
  perc.f=100/led()\ticks  
  percents.f=(percent/100)  
  finalpercent.f=percents*tickcount  
  stringpercent.s=StrF(finalpercent)  
  Result.f = Round(finalpercent, 1)  
  finalresult=led()\ticks-Result  
  ledheight=led()\height-20  
  boxwidth=(led()\width-10-1)/2  
  secondx=6+boxwidth  
   
  StartDrawing(ImageOutput(led()\imageid)) 
  tickcount=0  
  For a=0 To led()\height-20 Step 4  
    tickcount=tickcount+1  
    If tickcount>=finalresult  
      Box(5,a,boxwidth,3,$FF00)  
      Box(secondx,a,boxwidth,3,$FF00)  
    Else  
      Box(5,a,boxwidth,3,$7F00)  
      Box(secondx,a,boxwidth,3,$7F00)  
    EndIf  
  Next  
  Box(0,led()\height-15,led()\width,15,#Black)  
  BackColor(RGB(0,0,0)) 
  FrontColor(RGB(0, $FF, 0))  
  DrawText((led()\width/2)-10, led()\height-15, Str(percent)+"%")  
  StopDrawing()  
  SetGadgetState(led()\imagegad,ImageID(led()\imageid))  
EndProcedure  
 
Procedure Update_PDH_Usage(*Value)
Repeat
update_cpu_usage()
For ii=0 To NumCores;
	setLEDstate(ii,dCPU(ii))
	SetMeterGadgetState(ii+100,dCPU(ii))
Next
Delay(1000)
ForEver
EndProcedure

#WindowWidth  = 310  
#WindowHeight = 330  
If OpenWindow(0, 0, 0, #WindowWidth, #WindowHeight, "% cpu usage", #PB_Window_MinimizeGadget| #PB_Window_ScreenCentered)  
  si.SYSTEM_INFO
  GetSystemInfo_(@si)
  NumCores = si\dwNumberOfProcessors
	height.l:width.l
	If NumCores < 4
		For i=0 To NumCores-1 
			Frame3DGadget(i+10,10,10+200*i,410,200,"Core #" + Str(i))
			LedGadget(i,20,25+200*i,75,175,0)
			MeterGadget(i+100,115,25+200*i,290,175,RGB($0,$0,$0),RGB($0,$7F,$0),RGB($0,$FF,$0))
		Next
		width =430
		height = NumCores * 207
	ElseIf NumCores = 6
		For i=0 To NumCores-1 Step 3
			For iii=0 To 2
				Frame3DGadget(i+10+iii,10+ii*420,10+200*iii,410,200,"Core #" + Str(i+iii))
				LedGadget(i+iii,20+ii*420,25+200*iii,75,175,0)
				MeterGadget(i+100+iii,115+ii*420,25+200*iii,290,175,RGB($0,$0,$0),RGB($0,$7F,$0),RGB($0,$FF,$0))
			Next
			ii+1
		Next
		width = 850
		height = 621
	Else; NumCores = 8
		For i=0 To NumCores-1 Step 4
			For iii=0 To 3
				Frame3DGadget(i+10+iii,10+ii*420,10+200*iii,410,200,"Core #" + Str(i+iii))
				LedGadget(i+iii,20+ii*420,25+200*iii,75,175,0)
				MeterGadget(i+100+iii,115+ii*420,25+200*iii,290,175,RGB($0,$0,$0),RGB($0,$7F,$0),RGB($0,$FF,$0))
			Next
			ii+1
		Next
		width = 850
		height = 820
	EndIf
	If NumCores > 1
		ResizeWindow(0,#PB_Ignore,#PB_Ignore,width,height)
	EndIf  
initializecpu()
trd.i = CreateThread(@Update_PDH_Usage(),189)
  Repeat    
    EventID = WaitWindowEvent()  
     
    If EventID = #PB_Event_Gadget  
       
      Select EventGadget()  
        Case led  
           
      EndSelect  
       
    EndIf  
     
  Until EventID = #PB_Event_CloseWindow  
   
EndIf  
KillThread(trd)
close_cpu_usage()
End  
 
; IDE Options = PureBasic 4.51 (Windows - x64)
; CursorPosition = 88
; FirstLine = 81
; Folding = -
; EnableXP
; EnableAdmin
; Executable = ..\CPU_Usage_x64.exe
; DisableDebugger
; CurrentDirectory = F:\120GB\WInfo.exe\
; CompileSourceDirectory